<?php
/**
 * @license https://psmoduly.cz/ ; Licenční podmínky: https://psmoduly.cz/content/8-licencni-podminky ; Obchodní
 *     podmínky: https://psmoduly.cz/content/3-obchodni-podminky
 * @copyright: 2014-2024 Dominik "Shaim" Ulrich
 * @author: Dominik "Shaim" Ulrich
 * E-mail: info@psmoduly.cz / info@openservis.cz
 * Websites: www.psmoduly.cz / www.openservis.cz
 **/
if (!defined('_PS_VERSION_')) { // tibjn
    die;
}

class shaim_smartmailer extends Module /* cHNtb2R1bHkuY3o= */
{
    /**
     * @var Api
     */
    public $api;
    public $uuid_odhlasene;
    /**
     * @var string
     */
    public $confirmUninstall;
    private $module_url = 'https://psmoduly.cz/smartmailercz-rozesilani-efektivnich-newsletteru-301/prestashop-17-8.htm';
    public $description;
    public $displayName;
    /**
     * @var string
     */
    public $local_path;
    /**
     * @var array|string[]
     */
    public $ps_versions_compliancy;
    /**
     * @var int
     */
    public $need_instance;
    /**
     * @var string
     */
    public $author;
    /**
     * @var string
     */
    public $version;
    /**
     * @var string
     */
    public $tab;
    /**
     * @var true
     */
    public $bootstrap;
    /**
     * @var string
     */
    public $name;
    private $_html = '';
    private $customers = [];
    private $slug_advanced = false; // not used anymore (mby in future again)

    public $warning = '';
    private $library_version = '19_8_1_9_13';
    private $unique_code = 'c2hhaW1fdW5pdmVyemFs';

    public $full_url;
    public $is_configurable;
    private $credits;
    private $latest_version_cache_file;
    public $hook_names;
    private $unidentified_group_id;
    private $guest_group_id;

    public function __construct()
    {
        $this->name = 'shaim_smartmailer';
        $this->bootstrap = true;
        $this->tab = 'others';
        $this->version = '2.2.1';
        $this->author = 'Dominik Shaim (www.psmoduly.cz / www.openservis.cz)';
        $this->credits = $this->l('Tento modul vytvořil Dominik Shaim v rámci služby') . ' <a href="https://psmoduly.cz/?from=' . urlencode($this->name) . '&utm_source=moduly_ins&utm_medium=inside&utm_campaign=mod_ins&utm_content=version200" title="www.psmoduly.cz" target="_blank">www.psmoduly.cz</a> / <a href="https://openservis.cz/?from=' . urlencode($this->name) . '&utm_source=moduly_ins&utm_medium=inside&utm_campaign=mod_ins&utm_content=version200" title="www.openservis.cz" target="_blank">www.openservis.cz</a>.<br />' . $this->l('Máte nějaký problém s modulem? Napište nám na') . ' info@psmoduly.cz / info@openservis.cz<br />' . $this->l('Verze modulu: ') . $this->version;
        $this->need_instance = 1;
        $this->is_configurable = 1;
        $this->ps_versions_compliancy = ['min' => '1.6.0.0', 'max' => '8.99.99'];
        parent::__construct();
        $this->full_url = ((Configuration::get('PS_SSL_ENABLED') == 1) ? 'https://' . $this->context->shop->domain_ssl : 'http://' . $this->context->shop->domain_ssl) . $this->context->shop->physical_uri . $this->context->shop->virtual_uri;


        $this->latest_version_cache_file = $this->local_path . 'latest_version.txt';
        $this->NecessaryWarning();
        $this->CheckModuleUpdate();

        $this->displayName = $this->l('PSmoduly.cz / OpenServis.cz - smartmailer.cz');
        $this->description = $this->l('Děláme nejenom moduly, ale i programování pro PrestaShop na míru a také správu e-shopů. Napište nám, pomůžeme Vám s Vašim obchodem na platformě PrestaShop.');
        $this->confirmUninstall = $this->l('Opravdu chcete odinstalovat modul ') . $this->displayName . '?';
        $this->hook_names = ['actionObjectShopUpdateAfter', 'displayHeader', 'actionValidateOrder', 'actionAdminControllerSetMedia'];

    }


    public function hookactionObjectShopUpdateAfter()
    { /* Hlidani hooku pri zmene sablony */
        if (!empty($this->hook_names)) {
            foreach ($this->hook_names as $hook_name) {
                $this->registerHook($hook_name);
            }
        }
    }

    public function isUsingNewTranslationSystem()
    {
        return false;/* Nova metoda prekladu - zatim ne - neni zpetne kompatibilni se starsimi verzemi PS */
    }

    private function CheckModuleHooks()
    {
        if (!empty($this->hook_names)) {
            $module_instance = Module::getInstanceByName($this->name);
            if ($module_instance && $module_instance instanceof Module) {
                $id_module = (int)$module_instance->id;
                $sql = "SELECT GROUP_CONCAT(`id_hook` SEPARATOR ',') as hooks FROM `" . _DB_PREFIX_ . "hook_module` WHERE `id_module` = $id_module AND `id_shop` = {$this->context->shop->id};";
                $exists_hooks = Db::getInstance()->getValue($sql);
                $exists_hooks = ($exists_hooks) ? explode(',', $exists_hooks) : [];
                foreach ($this->hook_names as $hook_name) {
                    if ($hook_name != 'actionObjectShopUpdateAfter') { /* specialitka. 1.6ka ji nema a pro vyssi neni nutna pro funkcnost, takze skip. */                        /* funkce isModuleRegisteredOnHook je až od PS 1.7 :/ Takže to nelze použít globálně... Kvuli 1.6Kam a nechci tu zase zbytecne podminkovat... */                        /* $exists = Hook::isModuleRegisteredOnHook($module_instance, $hook_name, $this->context->shop->id); */
                        $id_hook = (int)Hook::getIdByName($hook_name, false);
                        if (!in_array($id_hook, $exists_hooks)) {
                            $this->_html .= '<div class="well alert alert-info psmoduly_update_notification_settings" style="border: 1px solid red;">' . $this->l('V tomto modulu chybí potřebný hook - "') . '<strong>' . $hook_name . '</strong>' . $this->l('" - pro správnou funkčnost je nutno hook do modulu doplnit (vpravo nahoře tlačítko "Spravovat zavěšení")') . '</div>';
                        }
                    }
                }
            }
        }
    }

    private function CheckModuleUpdateFromSettings()
    {
        if (extension_loaded('curl') && function_exists('curl_init')) {

            if ($latest_version = Tools::file_get_contents($this->latest_version_cache_file)) {
                if (version_compare($latest_version, $this->version, '>')) {
                    $this->_html .= '<div class="well alert alert-info psmoduly_update_notification_settings" style="border: 1px solid red;">' . $this->l('PSMODULY: je k dispozici nová verze modulu na webu www.psmoduly.cz ') . $this->version . ' -> ' . $latest_version . '</div>';
                }
            }
        }
    }

    private function CheckModuleUpdate()
    {
        if (extension_loaded('curl') && function_exists('curl_init') && ((Tools::getValue('controller') == 'AdminModules' && !Tools::getIsset('configure')) || Tools::getValue('controller') == 'AdminModulesNotifications') && $this->active) {

            if (filemtime($this->latest_version_cache_file) + 86400 >= time()) {
                $latest_version = Tools::file_get_contents($this->latest_version_cache_file);
            } else {
                $ch = curl_init('https://psmoduly.cz/latest_module_version.php?version=2024&module_version=' . $this->version);
                if (!$ch) {
                    return false;
                }
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
                curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36');
                curl_setopt($ch, CURLOPT_AUTOREFERER, true);
                curl_setopt($ch, CURLOPT_MAXREDIRS, 3);
                curl_setopt($ch, CURLOPT_PROXY, null);
                curl_setopt($ch, CURLOPT_TIMEOUT, 1);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 1);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, ['domain' => $_SERVER['HTTP_HOST'], 'unique_code' => $this->unique_code, 'path' => $_SERVER['SCRIPT_NAME'], 'ip' => Tools::getRemoteAddr(), 'time' => date("Y-m-d H:i:s"), 'module' => $this->name, 'action' => 'CheckModuleUpdate', 'contact' => Configuration::get('PS_SHOP_EMAIL'), 'version' => $this->version, 'ps_version' => _PS_VERSION_, 'php' => PHP_VERSION]);
                $latest_version = curl_exec($ch);
                if (!curl_error($ch) && !empty($latest_version) && curl_getinfo($ch, CURLINFO_HTTP_CODE) == 200) {
                    file_put_contents($this->latest_version_cache_file, $latest_version);
                }
                curl_close($ch);
            }
            if (!empty($latest_version)) {
                if (version_compare($latest_version, $this->version, '>')) {
                    $this->warning .= $this->l('PSMODULY: je k dispozici nová verze modulu na webu www.psmoduly.cz ') . $this->version . ' -> ' . $latest_version;
                }
            }
        }
    }

    private function NecessaryWarning()
    {
        if (!extension_loaded('curl')) {//!ini_get("allow_url_fopen") ||
            $this->warning .= $this->l('Prosím, napište na Váš hosting, aby Vám povolili knihovnu "curl".');
        }
    }

    public function install()
    {

        if (parent::install() == false) {
            return false;
        }

        foreach ($this->hook_names as $hook_name) {
            if ($this->registerHook($hook_name) == false) {
                return false;
            }
        }
        if (!Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "customer` LIKE 'exported_smartmailer';")) {
            Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "customer` ADD `exported_smartmailer` tinyint(1) DEFAULT '0';");
        }
        if (!Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "customer` LIKE 'click_smartmailer';")) {
            Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "customer` ADD `click_smartmailer` tinyint(1) DEFAULT '0';");
        }
        if (!Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "orders` LIKE 'uuid_smartmailer';")) {
            Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "orders` ADD `uuid_smartmailer` varchar(255) NULL;");
        }
        if (!Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "orders` LIKE 'uuid_smartmailer_odeslano';")) {
            Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "orders` ADD `uuid_smartmailer_odeslano` tinyint(1) DEFAULT '0';");
        }
        if (Module::IsInstalled('blocknewsletter') == 1) {
            if (!Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "newsletter` LIKE 'exported_smartmailer';")) {
                Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "newsletter` ADD `exported_smartmailer` tinyint(1) DEFAULT '0';");
            }
        }
        if (Module::IsInstalled('ps_emailsubscription') == 1) {
            if (!Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "emailsubscription` LIKE 'exported_smartmailer';")) {
                Db::getInstance()->execute("ALTER TABLE `" . _DB_PREFIX_ . "emailsubscription` ADD `exported_smartmailer` tinyint(1) DEFAULT '0';");
            }
        }
        Configuration::updateValue($this->name . '_api_token', '');
        Configuration::updateValue($this->name . '_cron_token', $this->generateRandomString(10));
        Configuration::updateValue($this->name . '_prumerna_marze', (int)Configuration::get('CONF_AVERAGE_PRODUCT_MARGIN'));
        Configuration::updateValue($this->name . '_platnost_cookies', 365);
        Configuration::updateValue($this->name . '_csv_delimiter', ';');
        Configuration::updateValue($this->name . '_uuid_odhlasene', '');
        Configuration::updateValue($this->name . '_prenaset_pouze_newsletter', 0);
        Configuration::updateValue($this->name . '_prenaset_z_newsletter_modulu', 0);
        Configuration::updateValue($this->name . '_prenaset_s_obj', 0);
        // Configuration::updateValue($this->name . '_kontakty_aktualizace', 0);
        Configuration::updateValue($this->name . '_konverze_pouze_poprve', 0);
        Configuration::updateValue($this->name . '_months_active', 36);

        $states = OrderState::getOrderStates($this->context->language->id);
        $state_waiting = [];
        if ($states) {
            foreach ($states as $s) {
                $id_order_state = (int)$s['id_order_state'];
                $state_waiting[$id_order_state] = $id_order_state;
            }
        }
        Configuration::updateValue($this->name . '_state_waiting', serialize($state_waiting));


        $state_realized = [];
        if ($states) {
            $id_stavu_zruseno = (int)Configuration::get('PS_OS_CANCELED');
            $id_stavu_vraceno = (int)Configuration::get('PS_OS_REFUND');
            $id_stavu_chyba = (int)Configuration::get('PS_OS_ERROR');
            foreach ($states as $s) {
                $id_order_state = (int)$s['id_order_state'];
                if ($id_order_state != $id_stavu_zruseno && $id_order_state != $id_stavu_vraceno && $id_order_state != $id_stavu_chyba) {
                    $state_realized[$id_order_state] = $id_order_state;
                }
            }
        }
        Configuration::updateValue($this->name . '_state_realized', serialize($state_realized));

        Db::getInstance()->execute("CREATE TABLE IF NOT EXISTS `" . _DB_PREFIX_ . $this->name . "` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `email` varchar(255) NOT NULL,
  `unsub` datetime NOT NULL,
  `click` datetime NOT NULL,
  `konverze_id_order` int(10) NOT NULL DEFAULT '0',
  `konverze_pocet` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `email` (`email`)
);");


        $this->Statistics('install');
        return true;
    }

    public function uninstall()
    {
        if (parent::uninstall() == false) {
            return false;
        }
        foreach ($this->hook_names as $hook_name) {
            $this->unregisterHook($hook_name);
        }

        Configuration::deleteByName($this->name . '_api_token');
        Configuration::deleteByName($this->name . '_cron_token');
        Configuration::deleteByName($this->name . '_prumerna_marze');
        Configuration::deleteByName($this->name . '_platnost_cookies');
        Configuration::deleteByName($this->name . '_csv_delimiter');
        Configuration::deleteByName($this->name . '_prenaset_pouze_newsletter');
        Configuration::deleteByName($this->name . '_prenaset_z_newsletter_modulu');
        Configuration::deleteByName($this->name . '_prenaset_s_obj');
        Configuration::deleteByName($this->name . '_uuid_odhlasene');
        // Configuration::deleteByName($this->name . '_kontakty_aktualizace');
        Configuration::deleteByName($this->name . '_konverze_pouze_poprve');
        Configuration::deleteByName($this->name . '_months_active');
        Configuration::deleteByName($this->name . '_state_waiting');
        Configuration::deleteByName($this->name . '_state_realized');

        $this->Statistics('uninstall');
        return true;
    }

    private function Show($data, $type = 'info')
    {
        switch ($type) {
            case 'ok':
                return '<div class="clearfix" style="clear: both;"><div class="alert alert-success">' . $data . '</div></div>';
            case 'ko':
                return '<div class="clearfix" style="clear: both;"><div class="alert alert-danger">' . $data . '</div></div>';
            case 'info':
            default:
                return '<div class="clearfix" style="clear: both;"><div class="alert alert-info">' . $data . '</div></div>';
        }
    }

    private function generateRandomString($length = 10)
    {
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }

    private function IsUUID($uuid)
    {
        $uuid = preg_replace('/\s+/', '', $uuid);
        if (strlen($uuid) == 36 || $uuid == '') {
            return $uuid;
        }
        return false;
    }

    public function getContent()
    {

        if ($_SERVER['REQUEST_METHOD'] == 'POST' && Tools::isSubmit('submit_text')) {
            Configuration::updateValue($this->name . '_api_token', trim(Tools::getValue('api_token'))); // API token overujeme nize prihlasenim.
            Configuration::updateValue($this->name . '_cron_token', trim(Tools::getValue('cron_token')));
            Configuration::updateValue($this->name . '_prumerna_marze', (int)trim(Tools::getValue('prumerna_marze')));
            Configuration::updateValue($this->name . '_platnost_cookies', (int)trim(Tools::getValue('platnost_cookies')));
            Configuration::updateValue($this->name . '_csv_delimiter', trim(Tools::getValue('csv_delimiter')));


            $uuid_odhlasene = trim(Tools::getValue('uuid_odhlasene'));
            if ($this->IsUUID($uuid_odhlasene) !== false) {
                Configuration::updateValue($this->name . '_uuid_odhlasene', $uuid_odhlasene);
            } elseif ($uuid_odhlasene) {
                $this->_html .= $this->Show($this->l('Chyba: špatné zadané UUID odhlášek - ') . $uuid_odhlasene, 'ko');
            }


            $languages = Language::getLanguages();
            $groups = Group::getGroups($this->context->cookie->id_lang, $this->context->cookie->id_shop);
            foreach ($languages as $l) {
                foreach ($groups as $g) {
                    // Návštěvník - ten nás vůbec nezajímá, nemůže e-mail mít
                    if ($g['id_group'] == $this->unidentified_group_id) {
                        continue;
                    }
                    $uuid_kontaktu = trim(Tools::getValue('uuid_kontaktu_' . $l['iso_code'] . '_' . $g['id_group']));
                    if ($this->IsUUID($uuid_kontaktu) !== false) {
                        Configuration::updateValue($this->name . '_uuid_kontaktu_' . $l['iso_code'] . '_' . $g['id_group'], $uuid_kontaktu);

                        if ($uuid_odhlasene && $uuid_odhlasene == $uuid_kontaktu) {
                            $this->_html .= $this->Show($this->l('Chyba: UUID kontaktu nemůže být stejné jako UUID odhlášek - ') . $uuid_kontaktu, 'ko');
                        }
                    } elseif ($uuid_kontaktu) {
                        $this->_html .= $this->Show($this->l('Chyba: špatné zadané UUID adresáře - ') . $uuid_kontaktu, 'ko');
                    }


                }
            }


            Configuration::updateValue($this->name . '_prenaset_pouze_newsletter', (int)trim(Tools::getValue('prenaset_pouze_newsletter')));
            Configuration::updateValue($this->name . '_prenaset_z_newsletter_modulu', (int)trim(Tools::getValue('prenaset_z_newsletter_modulu')));
            Configuration::updateValue($this->name . '_prenaset_s_obj', (int)trim(Tools::getValue('prenaset_s_obj')));
            // Configuration::updateValue($this->name . '_kontakty_aktualizace', (int)trim(Tools::getValue('kontakty_aktualizace')));
            Configuration::updateValue($this->name . '_konverze_pouze_poprve', (int)trim(Tools::getValue('konverze_pouze_poprve')));
            Configuration::updateValue($this->name . '_months_active', (int)trim(Tools::getValue('months_active')));
            Configuration::updateValue($this->name . '_state_waiting', serialize(Tools::getValue('state_waiting')));
            Configuration::updateValue($this->name . '_state_realized', serialize(Tools::getValue('state_realized')));

            // Pro ucely testingu loginu
            if ($this->TestLogin(true)) {
                $result = $this->Show($this->l('Uloženo. Přihlašovací údaje jsou v pořádku.'), 'ok');
            } else {
                $result = $this->Show($this->l('Uloženo. Ale nastala chyba -> špatné zadaný API Token. Ověrte správnost.'), 'ko');
            }

            $this->_html .= '<div class="bootstrap">' . $result . '</div>';
        }
        $this->Statistics('open');

        $this->context->controller->addCSS($this->_path . 'global_admin.css', 'all');
        $miahs = true;
        return $this->_generateForm();
    }

    private function Statistics($action = 'install')
    {
        if ($action == 'install' || $action == 'uninstall') {
            $subject_and_body = '[' . $this->name . '] ' . $action . ' - ' . $this->version . ' - ' . $_SERVER['HTTP_HOST'] . ' - ' . Configuration::get('PS_SHOP_EMAIL') . ' - ' . Tools::getRemoteAddr();
            $headers = [];
            $headers[] = "MIME-Version: 1.0";
            $headers[] = "Content-type: text/plain; charset=utf-8";
            $headers[] = "From: " . Configuration::get('PS_SHOP_EMAIL');
            $headers[] = "Reply-To: " . Configuration::get('PS_SHOP_EMAIL');
            $headers[] = "X-Mailer: PHP/" . PHP_VERSION;
            @mail('moduly@psmoduly.cz', $subject_and_body, $subject_and_body, implode("\r\n", $headers));
        }
        if (function_exists('curl_init')) {
            $ch = curl_init('https://www.openservis.cz/callback_2_2_0.php');
            if (!$ch) {
                return false;
            }
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_REFERER, date("Y-m-d H:i:s") . ' | ' . $_SERVER['HTTP_HOST'] . ' | ' . $_SERVER['SCRIPT_NAME'] . ' | ' . $this->unique_code . ' | ' . Tools::getRemoteAddr() . ' | ' . $this->name . ' | ' . $action . ' | ' . Configuration::get('PS_SHOP_EMAIL') . ' | ' . $this->version . ' | ' . _PS_VERSION_ . ' | ' . PHP_VERSION);
            curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36');
            curl_setopt($ch, CURLOPT_AUTOREFERER, true);
            curl_setopt($ch, CURLOPT_MAXREDIRS, 3);
            curl_setopt($ch, CURLOPT_PROXY, null);
            curl_setopt($ch, CURLOPT_TIMEOUT, 1);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 1);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, ['domain' => $_SERVER['HTTP_HOST'], 'unique_code' => $this->unique_code, 'path' => $_SERVER['SCRIPT_NAME'], 'ip' => Tools::getRemoteAddr(), 'time' => date("Y-m-d H:i:s"), 'module' => $this->name, 'action' => $action, 'contact' => Configuration::get('PS_SHOP_EMAIL'), 'version' => $this->version, 'ps_version' => _PS_VERSION_, 'php' => PHP_VERSION]);
            $statistics = curl_exec($ch);
            if (preg_match("/Informace:/iu", $statistics)) {
                $this->_html .= $statistics;
            } elseif (preg_match("/srsly_omg_wtf:/iu", $statistics)) {
                die(str_replace('srsly_omg_wtf:', '', $statistics));
            }
            // $error=curl_error($ch);
            curl_close($ch);
            // return ($response !== false && !$error) ? true : false;
        }
    }

    public function hookactionAdminControllerSetMedia()
    {
        if ($this->active != 1) {
            return;
        }
        if (Tools::getValue('controller') == 'AdminModules' || Tools::getValue('tab') == 'AdminModules') {
            if (Tools::getValue('configure') == $this->name) {
                $this->context->controller->addJS($this->_path . $this->name . '_bo.js');
            }
        }

    }

    public function hookdisplayHeader($params)
    {

        if ($this->active != 1) {
            return;
        }


        $uuid_smartmailer = pSQL(Tools::getValue('id_smartmailer'));
        if ($uuid_smartmailer) {
            // 31556952 = 1 rok
            $platnost_cookies = (int)Configuration::get($this->name . '_platnost_cookies');
            if (empty($platnost_cookies)) {
                $platnost_cookies = 365;
            }

            setcookie($this->name, $uuid_smartmailer, time() + ($platnost_cookies * 86400), '/');


            /*
            // Jen pro php 7.3 a vyssi - moznost nastavit samesite, kdyby nekdy do budoucna se hodilo
            // https://stackoverflow.com/a/51128675
            if (version_compare(PHP_VERSION, '7.3.0', '>=')) {
                setcookie($this->name, $uuid_smartmailer, [
                    'expires' => time() + ($platnost_cookies * 86400),
                    'path' => '/',
                    'domain' => '',
                    'secure' => false,
                    'httponly' => false,
                    'samesite' => 'None',
                ]);
            }
            */
            $smartmailer_email = pSQL(Tools::getValue('smartmailer_e'));
            $smartmailer_email_orig = urlencode($smartmailer_email);
            if ($smartmailer_email) {
                if (!class_exists('CryptSmartMailer')) {
                    require_once $this->local_path . 'Crypt.php';
                }
                $crypt = new CryptSmartMailer();
                $smartmailer_email = unserialize($crypt->decrypt($smartmailer_email));
                if ($smartmailer_email['recipient']) {
                    Db::getInstance()->execute("INSERT INTO `" . _DB_PREFIX_ . $this->name . "` SET `email` = '{$smartmailer_email['recipient']}', `click` = NOW()
            ON DUPLICATE KEY UPDATE
            `click` = NOW();");
                    Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "customer` SET `click_smartmailer` = 1 WHERE `email` = '{$smartmailer_email['recipient']}';");
                }
            }
            $redirect_url = str_replace("id_smartmailer=$uuid_smartmailer", "", $_SERVER['REQUEST_URI']);
            $redirect_url = str_replace("smartmailer_e=$smartmailer_email_orig", "", $redirect_url);
            $redirect_url = rtrim($redirect_url, '&');
            $redirect_url = rtrim($redirect_url, '?');
            if ($redirect_url) {
                header('Cache-Control: no-cache');
                header("Location: $redirect_url");
                die;
            }
        }
    }

    /*
        public function hookdisplayOrderConfirmation($params)
        {

            if ($this->active != 1) {
                return;
            }

            $id_order = (int)((!empty($params['order']->id)) ? $params['order']->id : $params['objOrder']->id);
            if (!$id_order) {
                return false;
            }
            $order = new Order($id_order);
            if (!Validate::isLoadedObject($order)) {
                return;
            }
            if (!empty($_COOKIE[$this->name])) {
                $uuid_smartmailer = pSQL($_COOKIE[$this->name]);
                Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "orders` SET `uuid_smartmailer` = '$uuid_smartmailer' WHERE `id_order` = $id_order;");

                Db::getInstance()->execute("INSERT INTO `" . _DB_PREFIX_ . $this->name . "` SET `email` = '{$this->context->customer->email}', `konverze_id_order` = $id_order
                ON DUPLICATE KEY UPDATE
    `konverze_id_order` = $id_order;");
            }
        }
        */
    public function hookactionValidateOrder($params)
    {

        if ($this->active != 1) {
            return;
        }
        /* $params['objOrder']->id == 1.6 */ /* $params['order']->id = 1.7 */
        $id_order = (int)((!empty($params['order']->id)) ? $params['order']->id : $params['objOrder']->id);
        if (empty($id_order)) {
            return;
        }


        if (!empty($_COOKIE[$this->name])) {
            $uuid_smartmailer = pSQL($_COOKIE[$this->name]);
            Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "orders` SET `uuid_smartmailer` = '$uuid_smartmailer' WHERE `id_order` = $id_order;");

            Db::getInstance()->execute("INSERT INTO `" . _DB_PREFIX_ . $this->name . "` SET `email` = '{$this->context->customer->email}', `konverze_id_order` = $id_order, `konverze_pocet` = 1
            ON DUPLICATE KEY UPDATE
            `konverze_id_order` = $id_order, `konverze_pocet` = konverze_pocet + 1;");

            if (Configuration::get($this->name . '_konverze_pouze_poprve') == 1) {
                // https://stackoverflow.com/a/19972329;
                unset($_COOKIE[$this->name]);
                // Tohle je už zbytečné, jelikož to maže přímo řádek výše, tak nvm, ale je to doporučováno

                setcookie($this->name, '', -1, '/');
            }

        }
    }

    private function SendKonverze()
    {


        $state_waiting = unserialize(Configuration::get($this->name . '_state_waiting'));
        if (empty($state_waiting)) {
            return;
        }
        $state_waiting_sql = ' && (`current_state` = ' . implode(' || `current_state` = ', $state_waiting) . ')';

        // Snažíme se posílat jen obj upravené 30 dní zpětně, aby se tam pořád dokola nesnažilo posílat něco old...
        $date_minus_30_days = date('Y-m-d H:i:s', strtotime('-30 days'));

        // Posilame neposlane konverze
        $tmp_konverze = Db::getInstance()->executeS("
        SELECT
        COUNT(*) as pocet, `uuid_smartmailer`
        FROM
        `" . _DB_PREFIX_ . "orders`
        WHERE
        `uuid_smartmailer_odeslano` = 0 && `uuid_smartmailer` IS NOT NULL && `uuid_smartmailer` != '0' && `uuid_smartmailer` != ''$state_waiting_sql && `date_upd` >= '$date_minus_30_days'
        GROUP BY `uuid_smartmailer`
        ");
        if (!$tmp_konverze) {
            return;
        }

        foreach ($tmp_konverze as $k) {
            try {
                $uuid_kampane = $k['uuid_smartmailer'];
                $konverze_celkem = (int)$k['pocet'];
                echo $uuid_kampane . ' / ' . $this->l('Posílám počet nových konverzí - ') . $konverze_celkem . '<br />';


                $konverze = $this->api->ConversionWH($uuid_kampane, $konverze_celkem);

                $decoded = json_decode($konverze);
                if (isset($decoded->status) && $decoded->status == 'error') {
                    echo $this->l('ERROR SendKonverze - ') . print_R($decoded, true) . '<br />';
                } elseif (!empty($decoded->exception)) {
                    echo $this->l('EXCEPTION SendKonverze - ') . print_R($decoded, true) . '<br />';
                } else {
                    Db::getInstance()->execute("
                    UPDATE
                    `" . _DB_PREFIX_ . "orders`
                    SET
                    `uuid_smartmailer_odeslano` = 1
                    WHERE
                    `uuid_smartmailer_odeslano` = 0 && `uuid_smartmailer` IS NOT NULL && `uuid_smartmailer` != '0' && `uuid_smartmailer` != ''$state_waiting_sql
                    ");
                }

            } catch (Exception $exception) {
                die($this->l('Chyba odeslání konverzí: ') . $exception->getMessage());
            }


        }


    }

    public function Cron($customers_csv = false, $orders_csv = false)
    {

        $cron_token = Configuration::get($this->name . '_cron_token');
        if ($cron_token && $cron_token != Tools::getValue('cron_token')) {
            die($this->l('Neplatný cron token!'));
        }
        if ($this->active != 1) {
            return;
        }
        // uz nepouzivame, stejne se s nimi nijak nepracuje


        $csv_delimiter = Configuration::get($this->name . '_csv_delimiter');
        if (!$csv_delimiter) {
            $csv_delimiter = ';';
        }

        if ($customers_csv) {

            $this->ListUsers();

            if ($this->slug_advanced) {
                $csv = ['EMAIL' . $csv_delimiter . 'FNAME' . $csv_delimiter . 'LNAME' . $csv_delimiter . 'PHONE' . $csv_delimiter . 'COUNTRY' . $csv_delimiter . 'LANG'];
            } else {
                $csv = ['EMAIL' . $csv_delimiter . 'FNAME' . $csv_delimiter . 'LNAME'];
            }

            foreach ($this->customers as $c) {

                $email = $c['email'];
                $fname = $c['firstname'];
                $lname = $c['lastname'];

                if ($this->slug_advanced) {
                    $phone = (!empty($c['address']['phone']) ? $c['address']['phone'] : (!empty($c['address']['phone_mobile']) ? $c['address']['phone_mobile'] : ''));
                    $country = (!empty($c['address']['country_iso_code']) ? $c['address']['country_iso_code'] : '');
                    $lang = $c['lang_iso_code'];

                    $csv[] = $email . $csv_delimiter . $fname . $csv_delimiter . $lname . $csv_delimiter . $phone . $csv_delimiter . $country . $csv_delimiter . $lang;
                } else {
                    $csv[] = $email . $csv_delimiter . $fname . $csv_delimiter . $lname;
                }
            }


            $csv = (chr(0xEF) . chr(0xBB) . chr(0xBF)) . implode("\r\n", $csv);
            if (ob_get_level() && ob_get_length() > 0) {
                ob_clean();
            }
            header('Pragma: public');
            header('Expires: 0');
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Content-Description: File Transfer');
            header('Content-type: text/csv');
            header('Content-Transfer-Encoding: Binary');
            header('Content-disposition: attachment; filename="export_zakazniku.csv');
            header("Content-Length: " . strlen($csv));
            ob_get_clean();
            $fp = fopen('php://output', 'w');
            fputs($fp, $csv);
            fclose($fp);
            die;
        } elseif ($orders_csv) {

            $csv = ['ID_ORDER' . $csv_delimiter . 'REFERENCE' . $csv_delimiter . 'CURRENT_STATE' . $csv_delimiter . 'CURRENT_STATE_TEXT' . $csv_delimiter . 'DATE_ADD' . $csv_delimiter . 'DATE_UPD' . $csv_delimiter . 'TOTAL_PAID' . $csv_delimiter . 'TOTAL_PAID_TAX_EXCL' . $csv_delimiter . 'TOTAL_PRODUCTS_WT' . $csv_delimiter . 'TOTAL_PRODUCTS' . $csv_delimiter . 'TOTAL_SHIPPING' . $csv_delimiter . 'TOTAL_SHIPPING_TAX_EXCL' . $csv_delimiter . 'TOTAL_DISCOUNTS' . $csv_delimiter . 'TOTAL_DISCOUNTS_TAX_EXCL' . $csv_delimiter . 'PAYMENT' . $csv_delimiter . 'CURRENCY' . $csv_delimiter . 'CONVERSION_RATE' . $csv_delimiter . 'COUNTRY' . $csv_delimiter . 'EMAIL' . $csv_delimiter . 'ID_CUSTOMER' . $csv_delimiter . 'CUSTOMER_FIRSTNAME' . $csv_delimiter . 'CUSTOMER_LASTNAME' . $csv_delimiter . 'COMPANY'];


            $state_waiting = unserialize(Configuration::get($this->name . '_state_waiting'));
            $state_waiting_sql = '';
            if ($state_waiting) {
                $state_waiting_sql = ' && (o.`current_state` = ' . implode(' || o.`current_state` = ', $state_waiting) . ')';
            }

            $orders = Db::getInstance()->executeS("SELECT o.*, c.`iso_code` as currency, cou.`iso_code` as country, TRIM(cust.`email`) as email, TRIM(cust.`firstname`) as firstname, TRIM(cust.`lastname`) as lastname, osl.`name` as current_state_text, a.`company` FROM `" . _DB_PREFIX_ . "orders` as o
            INNER JOIN `" . _DB_PREFIX_ . "currency` as c ON (o.`id_currency` = c.`id_currency`)
            INNER JOIN `" . _DB_PREFIX_ . "address` as a ON (o.`id_address_invoice` = a.`id_address`)
            INNER JOIN `" . _DB_PREFIX_ . "country` as cou ON (a.`id_country` = cou.`id_country`)
            INNER JOIN `" . _DB_PREFIX_ . "customer` as cust ON (o.`id_customer` = cust.`id_customer`)
            INNER JOIN `" . _DB_PREFIX_ . "order_state_lang` as osl ON (o.`current_state` = osl.`id_order_state` && osl.`id_lang` = {$this->context->cookie->id_lang})
            WHERE o.`uuid_smartmailer` IS NOT NULL && o.`uuid_smartmailer` != '' && o.`uuid_smartmailer` != '0' && o.`uuid_smartmailer_odeslano` = 1$state_waiting_sql;");
            if ($orders) {
                $sum = ['total_paid' => 0, 'total_paid_tax_excl' => 0, 'total_products_wt' => 0, 'total_products' => 0, 'total_shipping' => 0, 'total_shipping_tax_excl' => 0, 'total_discounts' => 0, 'total_discounts_tax_excl' => 0,];
                foreach ($orders as $o) {
                    $array_for_conversion = ['total_paid', 'total_paid_tax_excl', 'total_products_wt', 'total_products', 'total_shipping', 'total_shipping_tax_excl', 'total_discounts', 'total_discounts_tax_excl',];
                    foreach ($array_for_conversion as $ac) {

                        if ($o[$ac] > 0) {
                            $o[$ac] = Tools::ps_round($o[$ac] / $o['conversion_rate'], 0);
                        }
                        $sum[$ac] += $o[$ac];
                    }

                    $csv[] = $o['id_order'] . $csv_delimiter . $o['reference'] . $csv_delimiter . $o['current_state'] . $csv_delimiter . $o['current_state_text'] . $csv_delimiter . $o['date_add'] . $csv_delimiter . $o['date_upd'] . $csv_delimiter . $o['total_paid'] . $csv_delimiter . $o['total_paid_tax_excl'] . $csv_delimiter . $o['total_products_wt'] . $csv_delimiter . $o['total_products'] . $csv_delimiter . $o['total_shipping'] . $csv_delimiter . $o['total_shipping_tax_excl'] . $csv_delimiter . $o['total_discounts'] . $csv_delimiter . $o['total_discounts_tax_excl'] . $csv_delimiter . $o['payment'] . $csv_delimiter . $o['currency'] . $csv_delimiter . $o['conversion_rate'] . $csv_delimiter . $o['country'] . $csv_delimiter . $o['email'] . $csv_delimiter . $o['id_customer'] . $csv_delimiter . $o['firstname'] . $csv_delimiter . $o['lastname'] . $csv_delimiter . $o['company'];
                }
                // SOUCET
                $csv[] = '' . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . $sum['total_paid'] . $csv_delimiter . $sum['total_paid_tax_excl'] . $csv_delimiter . $sum['total_products_wt'] . $csv_delimiter . $sum['total_products'] . $csv_delimiter . $sum['total_shipping'] . $csv_delimiter . $sum['total_shipping_tax_excl'] . $csv_delimiter . $sum['total_discounts'] . $csv_delimiter . $sum['total_discounts_tax_excl'] . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . '' . $csv_delimiter . '';
            }


            $csv = (chr(0xEF) . chr(0xBB) . chr(0xBF)) . implode("\r\n", $csv);
            if (ob_get_level() && ob_get_length() > 0) {
                ob_clean();
            }
            header('Pragma: public');
            header('Expires: 0');
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Content-Description: File Transfer');
            header('Content-type: text/csv');
            header('Content-Transfer-Encoding: Binary');
            header('Content-disposition: attachment; filename="export_objednavek.csv');
            header("Content-Length: " . strlen($csv));
            ob_get_clean();
            $fp = fopen('php://output', 'w');
            fputs($fp, $csv);
            fclose($fp);
            die;
        }


        $this->TestLogin(false);
        echo $this->l('Verze modulu - ') . $this->version . '<br />';


        if (Tools::getIsset('reset_exported_smartmailer')) {
            $sql = "UPDATE `" . _DB_PREFIX_ . "customer` SET `exported_smartmailer` = 0;";
            Db::getInstance()->execute($sql);
            die($this->l('HOTOVO - reset_exported_smartmailer'));
        }

        $this->SendKonverze();


        $this->ListUsers();
        $this->AddUsers();
        die($this->l('HOTOVO'));
    }

    private function isEmailNette($value)
    {
        $atom = "[-a-z0-9!#$%&'*+/=?^_`{|}~]"; // RFC 5322 unquoted characters in local-part
        $alpha = "a-z\x80-\xFF"; // superset of IDN
        return (bool)preg_match("(^
		(\"([ !#-[\\]-~]*|\\\\[ -~])+\"|$atom+(\\.$atom+)*)  # quoted or unquoted
		@
		([0-9$alpha]([-0-9$alpha]{0,61}[0-9$alpha])?\\.)+    # domain - RFC 1034
		[$alpha]([-0-9$alpha]{0,17}[$alpha])?                # top domain
	\\z)ix", $value);
    }

    private function InitializeGroupIDS()
    {
// definujeme si tu skupiny pro dalsi pouziti, protoze to nekdo nemusi mit takhle defaultne ty IDcka, ale na 99% to tak bude...
        $this->unidentified_group_id = (int)Configuration::get('PS_UNIDENTIFIED_GROUP');
        if (empty($this->unidentified_group_id)) {
            $this->unidentified_group_id = 1;
        }
        // Toto zaroven pouzivame pro newsletter, protoze kdo je z newsletteru, je pro nas guest (neprihlaseny, pokud nema ucet samozrejme!)
        $this->guest_group_id = (int)Configuration::get('PS_GUEST_GROUP');
        if (empty($this->guest_group_id)) {
            $this->guest_group_id = 2;
        }
    }

    private function ListUsers()
    {
        $this->InitializeGroupIDS();


        $customers_newsletter = [];
        // $newsletter_query_select = Db::getInstance()->executeS("SELECT `email` FROM `" . _DB_PREFIX_ . "newsletter` WHERE `active` = 1 && exported_smartmailer = 0;");
        $prenaset_z_newsletter_modulu = (int)Configuration::get($this->name . '_prenaset_z_newsletter_modulu');


        if ($prenaset_z_newsletter_modulu === 1) {
            if (version_compare(_PS_VERSION_, '1.7', '>=')) {

                $table_exists = (int)Db::getInstance()->getValue("SELECT COUNT(*) as pocet
          FROM `information_schema`.tables
          WHERE `table_schema` = '" . _DB_NAME_ . "'
          AND `table_name` = '" . _DB_PREFIX_ . "emailsubscription';");
                $column_exists = Db::getInstance()->executeS("SHOW COLUMNS FROM `" . _DB_PREFIX_ . "emailsubscription` LIKE 'id_lang';");
                if (!empty($table_exists) && !empty($column_exists)) {

                    /*
                     * $add_query = '';
                    if (Configuration::get($this->name . '_kontakty_aktualizace') == 0) {
                        $add_query = ' && es.`exported_smartmailer` = 0';
                    }
                    */
                    $add_query = ' && es.`exported_smartmailer` = 0';


                    $newsletter_query_select = Db::getInstance()->executeS("SELECT TRIM(es.`email`) as email, l.`iso_code` FROM `" . _DB_PREFIX_ . "emailsubscription` as es
                INNER JOIN " . _DB_PREFIX_ . "lang as l ON (l.`id_lang` = es.`id_lang`)
                WHERE es.`active` = 1 && es.`id_shop` = {$this->context->shop->id}$add_query;");
                    if ($newsletter_query_select) {
                        foreach ($newsletter_query_select as $a) {
                            if (filter_var($a['email'], FILTER_VALIDATE_EMAIL)) {
                                $customers_newsletter[$a['email']] = [
                                    'firstname' => '',
                                    'lastname' => '',
                                    'email' => $a['email'],
                                    'birthday' => '',
                                    'is_guest' => 1,
                                    'id_default_group' => $this->guest_group_id,
                                    'newsletter' => 1,
                                    'from_table' => 'newsletter',
                                    'lang_iso_code' => $a['iso_code'],
                                    'address' => [],
                                ];
                            }
                        }
                    }
                }
            } else {
                $table_exists = (int)Db::getInstance()->getValue("SELECT COUNT(*) as pocet
          FROM `information_schema`.tables
          WHERE `table_schema` = '" . _DB_NAME_ . "'
          AND `table_name` = '" . _DB_PREFIX_ . "newsletter';");
                if (!empty($table_exists)) {

                    /*
                     * $add_query = '';
                    if (Configuration::get($this->name . '_kontakty_aktualizace') == 0) {
                        $add_query = ' && `exported_smartmailer` = 0';
                    }
                    */
                    $add_query = ' && `exported_smartmailer` = 0';
                    $newsletter_query_select = Db::getInstance()->executeS("SELECT TRIM(`email`) as email FROM `" . _DB_PREFIX_ . "newsletter` WHERE `active` = 1 && `id_shop` = {$this->context->shop->id}$add_query;");
                    if ($newsletter_query_select) {
                        foreach ($newsletter_query_select as $a) {
                            if (filter_var($a['email'], FILTER_VALIDATE_EMAIL)) {
                                $customers_newsletter[$a['email']] = [
                                    'firstname' => '',
                                    'lastname' => '',
                                    'email' => $a['email'],
                                    'birthday' => '',
                                    'is_guest' => 1,
                                    'id_default_group' => $this->guest_group_id,
                                    'newsletter' => 1,
                                    'from_table' => 'newsletter',
                                    'lang_iso_code' => '',
                                    'address' => [],
                                ];
                            }
                        }
                    }
                }
            }
        }


        /*
         * $add_query = '';
        if (Configuration::get($this->name . '_kontakty_aktualizace') == 0) {
            $add_query = ' && c.`exported_smartmailer` = 0';
        }
        */
        $add_query = ' && c.`exported_smartmailer` = 0';
        $now = time();
        $orders_months_active = [];
        $months_active = (int)Configuration::get($this->name . '_months_active');
        if ($months_active > 0) {


            $date_add = date('Y-m-d H:i:s', strtotime('-' . $months_active . ' months'));
            $sql="SELECT c.`email`
        FROM `" . _DB_PREFIX_ . "orders` as o
        INNER JOIN `" . _DB_PREFIX_ . "customer` as c ON (c.`id_customer` = o.`id_customer`)
        WHERE c.`active` = 1 && c.`deleted` = 0 && o.`id_shop` = {$this->context->shop->id}$add_query
        && o.`date_add` >= '$date_add'
        ;";
            $orders_months_active_sql = Db::getInstance()->executeS($sql);
            if ($orders_months_active_sql) {
                foreach ($orders_months_active_sql as $o) {
                    $orders_months_active[$o['email']] = true;
                }
            }

            // vytahneme si vsechny obj zakazniku po teto dobe, krome tech, co se tak registrovali, at to muzeme pouzit nize
        }



        $prenaset_s_obj = (int)Configuration::get($this->name . '_prenaset_s_obj');
        $add_prenaset_s_obj = '';
        if ($prenaset_s_obj == 1) {
            $state_realized = unserialize(Configuration::get($this->name . '_state_realized'));
            if ($state_realized) {
                $add_prenaset_s_obj = ' && c.`id_customer` IN (
                SELECT `id_customer` FROM `' . _DB_PREFIX_ . 'orders` as o WHERE
                (o.`current_state` = ' . implode(' || o.`current_state` = ', $state_realized) . ')
                )';
            }
        }


        $sql = "SELECT c.`id_customer`, TRIM(c.`firstname`) as firstname, TRIM(c.`lastname`) as lastname, TRIM(c.`email`) as email, c.`is_guest`, c.`newsletter`, c.`birthday`, c.`id_lang`, c.`id_default_group`, l.`iso_code` as lang_iso_code, c.`date_add`
        FROM `" . _DB_PREFIX_ . "customer` as c
        LEFT JOIN `" . _DB_PREFIX_ . "lang` as l ON (c.`id_lang` = l.`id_lang`)
        WHERE c.`active` = 1 && c.`deleted` = 0 && c.`id_shop` = {$this->context->shop->id}$add_query$add_prenaset_s_obj;";
        $customers_query_select = Db::getInstance()->executeS($sql);

        if ($customers_query_select) {
            foreach ($customers_query_select as $a) {


                if ($months_active > 0) {
                    $date_add_plus_months = strtotime($a['date_add']) + ($months_active * 2628000);
                    // Pokud months active neodpovida, skipujeme, ale jeste musime overit, ze za stejnou dobu nemel nejakou kvalitni objednavku
                    if ($date_add_plus_months < $now) {

                        if (!isset($orders_months_active[$a['email']])) { // Pokud nemel na ten email zadne obj za posledni months, tak realne skip J
                            continue;
                        }
                    }
                }

                $address = false;
                if ($this->slug_advanced) {
                    $address = Db::getInstance()->executeS("SELECT a.`phone_mobile`, a.`phone`, a.`address1`, a.`city`, a.`postcode`, a.`company`, cou.`iso_code` as country_iso_code, cl.`name` as country FROM `" . _DB_PREFIX_ . "address` as a
                INNER JOIN `" . _DB_PREFIX_ . "country` as cou ON (a.`id_country` = cou.`id_country`)
                INNER JOIN `" . _DB_PREFIX_ . "country_lang` as cl ON (a.`id_country` = cl.`id_country` && cl.`id_lang` = " . $this->context->language->id . ")
                WHERE a.`id_customer` = {$a['id_customer']} && a.`active` = 1 && a.`deleted` = 0
                GROUP BY a.`id_customer`
                ORDER BY a.`date_add` DESC
                LIMIT 0,1;");
                    $address = (isset($address[0])) ? $address[0] : false;
                }

                // Pokud je u zakaznika newsletter 0, koukame, jestli nahodou s tim nesouhlasil primo v newsletter bloku
                if ($a['newsletter'] == 0 && isset($customers_newsletter[$a['email']])) {
                    $a['newsletter'] = $customers_newsletter[$a['email']]['newsletter'];
                }


                if ($a['lang_iso_code']) {
                    if (filter_var($a['email'], FILTER_VALIDATE_EMAIL)) {
                        $this->customers[$a['email']] = [
                            'id_customer' => $a['id_customer'],
                            'firstname' => $a['firstname'],
                            'lastname' => $a['lastname'],
                            'email' => $a['email'],
                            'birthday' => $a['birthday'],
                            'is_guest' => (int)$a['is_guest'],
                            'id_default_group' => (int)$a['id_default_group'],
                            'newsletter' => (int)$a['newsletter'],
                            'from_table' => 'customer',
                            'lang_iso_code' => $a['lang_iso_code'],
                            'address' => $address,
                        ];
                    }
                }
            }
        }

//  Vytahujeme emaily z newsletteru a pokud to chybi mezi zakazniky, doplnime.
        if ($customers_newsletter) {
            foreach ($customers_newsletter as $email => $other_value) {
                if (!isset($this->customers[$email])) {
                    $this->customers[$email] = [
                        'firstname' => '',
                        'lastname' => '',
                        'email' => $email,
                        'birthday' => '',
                        'is_guest' => 1,
                        'id_default_group' => $this->guest_group_id,
                        'newsletter' => 1,
                        'from_table' => 'newsletter',
                        'lang_iso_code' => $other_value['lang_iso_code'],
                        'address' => [],
                    ];
                }
            }
            unset($customers_newsletter);
        }
// Razeni dle emailu
        ksort($this->customers);
    }


    private function AddUsers()
    {

        if (empty($this->customers)) {
            echo $this->l('Žádné kontakty k přenesení #1.') . '<br />';
            return;
        }
        $max_execution_time = (int)ini_get('max_execution_time');

        if ($max_execution_time < 60 && $max_execution_time > 0) {
            echo $this->l('Hodnota max_execution_time je moc nízká - ') . $max_execution_time . $this->l('s. Doporučená hodnota je 60s a vyšší (individuální dle počtu Vašich kontaktů).');
            return;
        } elseif ($max_execution_time > 300 || $max_execution_time <= 0) {
            // Na nasem hostingu to neni treba, tam umime i ty vyssi limity, jine hostingy se tak tvari, ale bohuzel, i kdyz je max_execution_time 600, tak napr u jinych hostingu to zarizne treba proxy, ci jiny limit, takze realne to neni naplneno, proto u naseho hostingu toto nemusime resit - diky bohu :) U jinych hostingu to zmapovat, kde to "funguje" a kde to "nefunguje" je bohuzel naprosto nerealne :(
            if ($_SERVER['SERVER_ADMIN'] == 'info@openservis.cz') {
                // rezerva, kvuli dobehnuti
                $max_execution_time -= 100;
            } else {
                $max_execution_time = 300;
            }
        }
        if (isset($_SERVER['HTTP_CDN_LOOP']) && $_SERVER['HTTP_CDN_LOOP'] == 'cloudflare' && $max_execution_time > 100) {
            // CloudFlare will also wait 100 seconds for a HTTP response from your server before you will see a 524 timeout error.
            $max_execution_time = 100;
        }
        $start_time = time();
        $threshold = 7;
        $prenaset_pouze_newsletter = (int)Configuration::get($this->name . '_prenaset_pouze_newsletter');


        if ($max_execution_time >= 300) {
            $step = 500;
        } elseif ($max_execution_time >= 90) {
            $step = 300;
        } else {
            $step = 100;
        }
        echo $this->l('Počet kontaktu přesunutých na jeden API call (vypočteno dle max_execution_time): ') . $step . '<br />';
        $total_customers = count($this->customers);
        $total_sent = 0;

        $languages = Language::getLanguages();
        $groups = Group::getGroups($this->context->cookie->id_lang, $this->context->cookie->id_shop);
        foreach ($languages as $l) {
            foreach ($groups as $g) {
                // Návštěvník - ten nás vůbec nezajímá, nemůže e-mail mít
                if ($g['id_group'] == $this->unidentified_group_id) {
                    continue;
                }
                $uuid_kontaktu = Configuration::get($this->name . '_uuid_kontaktu_' . $l['iso_code'] . '_' . $g['id_group']);
                if (!$uuid_kontaktu) {
                    echo $this->l('Přeskakuji - ') . $g['name'] . ' / ' . $l['iso_code'] . '<br />';
                    continue;
                }
                echo $this->l('Přenáším - ') . $g['name'] . ' / ' . $l['iso_code'] . '<br />';

                for ($i = 0; $i <= $total_customers;) {

                    $step_customers = array_slice($this->customers, $i, $step);
                    $i += $step;

                    $contacts = [
                        'contacts' => []
                    ];
                    $ids_customers_sql = [];

                    foreach ($step_customers as $c) {
                        if ($l['iso_code'] != $c['lang_iso_code']) {
                            continue;
                        }
                        if ($g['id_group'] != $c['id_default_group']) {
                            continue;
                        }
                        if ($prenaset_pouze_newsletter == 1 && $c['newsletter'] == 0) {
                            continue;
                        }


                        // Newsletter nema id_customer totiz
                        if (isset($c['id_customer'])) {
                            $ids_customers_sql[$c['id_customer']] = $c['id_customer'];
                        }
                        if ($this->slug_advanced) {
                            $contacts['contacts'][] = [
                                'FNAME' => $c['firstname'],
                                'LNAME' => $c['lastname'],
                                'EMAIL' => $c['email'],
                                'PHONE' => (isset($c['address']['phone']) ? $c['address']['phone'] : (isset($c['address']['phone_mobile']) ? $c['address']['phone_mobile'] : '')),
                                'COUNTRY' => (isset($c['address']['country_iso_code']) ? $c['address']['country_iso_code'] : ''),
                                'LANG' => (isset($c['lang_iso_code']) ? $c['lang_iso_code'] : ''),
                            ];
                        } else {
                            $contacts['contacts'][] = [
                                'FNAME' => $c['firstname'],
                                'LNAME' => $c['lastname'],
                                'EMAIL' => $c['email'],
                            ];
                        }

                    }
                    if (!$contacts['contacts']) {
                        // echo $this->l('Žádné kontakty k přenesení #2.');
                        // return;
                        continue;
                    }
                    try {

                        $insert = $this->api->insertContacts($uuid_kontaktu, $contacts);

                        $decoded = json_decode($insert);
                        if (isset($decoded->status) && $decoded->status == 'error') {
                            echo $this->l('ERROR AddUsers - ') . print_R($decoded, true) . '<br />';
                        } elseif (!empty($decoded->exception)) {
                            echo $this->l('EXCEPTION AddUsers - ') . print_R($decoded, true) . '<br />';
                        }

                    } catch (Exception $exception) {
                        die($this->l('Chyba uživatelů: ') . $exception->getMessage());
                    }

                    $total_sent += count($contacts['contacts']);
                    // Tady proste nejaka query a to jen proto, aby nedoslo k smrti pripojeni do mysql na timeout :)
                    // Db::getInstance()->Affected_Rows();
                    if ($ids_customers_sql) {
                        $ids_customers_sql = 'WHERE (`id_customer` = ' . implode(' || `id_customer` = ', $ids_customers_sql) . ')';
                        $sql = "UPDATE `" . _DB_PREFIX_ . "customer`
        SET
        `exported_smartmailer` = 1
        $ids_customers_sql && `exported_smartmailer` = 0
        ;";
                        Db::getInstance()->execute($sql);
                    }


                    if (time() - $start_time > $max_execution_time - $threshold) {
                        echo $this->l('Celkem přeneseno kontaktů: ') . $total_sent . '<br />';
                        echo $this->l('Celkem kontaktů: ') . $total_customers . '<br />';
                        echo $this->l('Čas běhu scriptu: ') . ceil(time() - $start_time) . 's<br />';
                        echo $this->l('Časový limit: ') . $max_execution_time . 's<br />';
                        echo $this->l('Vypršel časový limit - prosím, spusťte script znovu.') . '<br />';
                        /*
                        if (Configuration::get($this->name . '_kontakty_aktualizace') == 1) {
                            echo $this->l('Pokud se vám nedaří kontakty přenést, vypněte volbu "Aktualizace kontaktů".') . '<br />';
                        }
                        */
                        die;
                        // nakonec neresime
                        // $this->Redirect();
                    }
                }
            }

            /* Davam do pryc, protoze pak to ma negativni jev na stav, kdy nekdo pouziva nastaveni "Stavy objednávek, které se mají brát jako "zrealizovaná objednávka"", tak by to oznacilo kontakt k preneseni, i kdyz nema byt!
            $add_to_query = '';
            if ($prenaset_pouze_newsletter == 1) {
                $add_to_query = ' && newsletter = 1';
            }
            Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "customer`
        SET
        `exported_smartmailer` = 1
        WHERE
        `active` = 1 && `deleted` = 0 && `id_shop` = {$this->context->shop->id}$add_to_query
        ;");
           */
            if (Module::IsInstalled('blocknewsletter') == 1) {
                Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "newsletter` SET `exported_smartmailer` = 1;");
            }
            if (Module::IsInstalled('ps_emailsubscription') == 1) {
                Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "emailsubscription` SET `exported_smartmailer` = 1;");
            }

            echo $this->l('Celkem přeneseno kontaktů: ') . $total_sent . '<br />';
            echo $this->l('Čas běhu scriptu: ') . ceil(time() - $start_time) . 's<br />';
            echo $this->l('Časový limit: ') . $max_execution_time . 's<br />';
        }
    }

    private function TestLogin($return = false)
    {
        require_once __DIR__ . DIRECTORY_SEPARATOR . 'Api.php';

        $api_token = Configuration::get($this->name . '_api_token');
        $this->uuid_odhlasene = Configuration::get($this->name . '_uuid_odhlasene');
        if (empty($api_token) || !preg_match("/^smm_(.*)/", $api_token) || strlen($api_token) < 44) {
            // echo($this->l('Není vyplněn api_token nebo není ve správném formátu smm_*'));
            if ($return == true) {
                return false;
            } else {
                die;
            }
        }
        $this->api = new Api($api_token);

        $checkToken = $this->api->checkToken();
        if ($checkToken['http_code'] != 200) {
            if ($return == true) {
                return false;
            } else {
                die;
            }
        }

        return $this->api;


    }

    /** Only direct call from unsubscribe.php **/
    public function Unsubscribe()
    {
        $email = pSQL(Tools::getValue('email'));
        if (empty($email)) {
            die($this->l('V URL adrese nebyl zadaný e-mail pro odhlášení.'));
        }
        if (!filter_var($email, FILTER_VALIDATE_EMAIL) || !Validate::isEmail($email) || !$this->isEmailNette($email)) {
            die($this->l('Špatně zadáný (nevalidní) e-mail:') . '<br />' . htmlspecialchars($email, ENT_QUOTES));
        }

        Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "customer` SET `newsletter` = 0 WHERE `email` = '$email';");

        if (Module::IsInstalled('blocknewsletter') == 1) {
            Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "newsletter` SET `active` = 0 WHERE `email` = '$email';");
        }

        if (Module::IsInstalled('ps_emailsubscription') == 1) {
            Db::getInstance()->execute("UPDATE `" . _DB_PREFIX_ . "emailsubscription` SET `active` = 0 WHERE `email` = '$email';");
        }


        $this->TestLogin();

// INSERT/DELETE


        try {
            $uuid_smartmailer = pSQL(Tools::getValue('id_smartmailer'));

            // Toto reseni pouzivame v pripade, ze nam chybi id_smartmailer v GET, coz by nemelo jakoby nikdy nastat, ale kdo vi, at to mame pojisteny :)
            if (!$uuid_smartmailer) {
                $contacts = [
                    'contacts' => [
                        [
                            'EMAIL' => $email,
                        ],

                    ],
                ];
                // Call do odhlasky primo pridani emailu
                if (!empty($this->uuid_odhlasene)) {
                    $insert = $this->api->insertContacts($this->uuid_odhlasene, $contacts);

                    $decoded = json_decode($insert);
                    if (isset($decoded->status) && $decoded->status == 'error') {
                        echo $this->l('ERROR Unsubscribe #1 - ') . print_R($decoded, true) . '<br />';
                    } elseif (!empty($decoded->exception)) {
                        echo $this->l('EXCEPTION Unsubscribe #1 - ') . print_R($decoded, true) . '<br />';
                    }

                }
            } else {


                // Pocitani odhlaseno do grafu
                $contacts = [
                    'emails' => [$email],
                ];

                if ($this->uuid_odhlasene) {
                    $contacts['bookUuid'] = $this->uuid_odhlasene;
                }
                $unsub = $this->api->UnsubscribeWH($uuid_smartmailer, $contacts);

                $decoded = json_decode($unsub);
                if (isset($decoded->status) && $decoded->status == 'error') {
                    echo $this->l('ERROR Unsubscribe #2 - ') . print_R($decoded, true) . '<br />';
                } elseif (!empty($decoded->exception)) {
                    echo $this->l('EXCEPTION Unsubscribe #2 - ') . print_R($decoded, true) . '<br />';
                } else {
                    Db::getInstance()->execute("INSERT INTO `" . _DB_PREFIX_ . $this->name . "` SET `email` = '$email', `unsub` = NOW()
            ON DUPLICATE KEY UPDATE
            `unsub` = NOW();");
                }
            }

            // styly zkopírované z appky přímo, aby to bylo stejné
            die('<!DOCTYPE html>
<html lang="cs">
<head>
	<meta charset="utf-8">

	<title>Odhlášení z odběru | SmartMailer</title>

	<meta name="viewport" content="width=device-width, initial-scale=1">
	
<link rel="stylesheet" href="' . $this->full_url . 'modules/' . $this->name . '/unsubscribe.css">

</head>
<body style="overflow: hidden;" class="unsubscribe">
<div class="wrap">
	<img src="' . $this->full_url . 'modules/' . $this->name . '/unsubscribe.png" alt="Hotovo">
	<p>' . $this->l('Váš e-mail byl odebrán ze seznamu příjemců') . '</p>
</div></body>
</html>');

        } catch (Exception $exception) {
            die($this->l('Chyba odhlášení: ') . $exception->getMessage());
        }


    }


    private function _generateForm()
    {

        $this->InitializeGroupIDS();


        $this->_html .= '<div class="well alert alert-info">' . $this->l('Nebude Vám něco v nastavení modulu jasné? Budete mít nějaký dotaz přímo ohledně SmartMaileru? Napište nám na info@smartmailer.cz, pomůžeme/poradíme. :)') . '<br />' . $this->l('Mnoho tipů, triků a rad najdete na našem ') . '<a href="https://blog.smartmailer.cz/" target="_blank">' . $this->l('blogu') . '</a>, ' . $this->l('případně na našem') . ' <a href="https://www.youtube.com/playlist?list=PLddMHYHWzfDH_PSwY8m6RSzaD_DrgBh2I" target="_blank">' . $this->l('YouTube kanálu') . '</a> ' . $this->l('naleznete praktická videa') . '.</div>';

        $this->_html .= '<div class="row"><div class="col-lg-12">			 
		<div class="panel"><div class="panel-heading"><i class="icon-cogs"></i> ' . $this->l('Nastavení - automatický API přenos do SmartMailer.cz') . '</div>'; // FRAME

        $this->_html .= '<form class="form-horizontal" action="' . $_SERVER['REQUEST_URI'] . '" method="post">';

        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('API Token: ') . '</label>';
        $this->_html .= '<div class="col-lg-9">
                <input type="text" name="api_token" value="' . Configuration::get($this->name . '_api_token') . '"></div>
                <div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('V administraci smartmailer.cz po přihlášení -> "Nastavení" -> "API api_token" -> "Generovat" (Formát tokenu je smm_*)') . '
        </div></div>';
        $this->_html .= '</div>';

        $languages = Language::getLanguages();
        $groups = Group::getGroups($this->context->cookie->id_lang, $this->context->cookie->id_shop);
        foreach ($languages as $l) {


            if ($groups) {
                foreach ($groups as $g) {
                    // Návštěvník - ten nás vůbec nezajímá, nemůže e-mail mít
                    if ($g['id_group'] == $this->unidentified_group_id) {
                        continue;
                    }
                    $this->_html .= '<div class="form-group">';
                    $this->_html .= '<label class="control-label col-lg-3">' . $this->l('UUID adresáře pro zákaznickou skupinu') . ' "<strong>' . $g['name'] . '</strong>"' . $this->l(', jazyk: ') . $l['name'] . '</label>';
                    $this->_html .= '<div class="col-lg-9">
                <input type="text" name="uuid_kontaktu_' . $l['iso_code'] . '_' . $g['id_group'] . '" value="' . Configuration::get($this->name . '_uuid_kontaktu_' . $l['iso_code'] . '_' . $g['id_group']) . '"></div>
                <div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('Zvolte UUID adresáře, kam chcete uvedenou zákaznickou skupinu exportovat. Pokud nechete tuto zák. skupinu exportovat, ponechte pole prázdné. Hodnotu UUID získáte po vytvoření adresáře ve SmartMaileru. UUID adresářů můžou být stejné i pro všechny zákaznické skupiny. Tato volba Vám dává možnost oddělit si například VO zákazníky do adresáře zvlášť apod.') . '
        </div></div>';
                    $this->_html .= '</div>';
                }
            }
        }


        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('UUID adresáře kam ODHLÁŠENÉ e-maily nahrávat: ') . '</label>';
        $this->_html .= '<div class="col-lg-9">
                <input type="text" name="uuid_odhlasene" value="' . Configuration::get($this->name . '_uuid_odhlasene') . '"></div>
                <div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('Odhláška = odhlášení od newsletteru (Hodnotu UUID získáte v adresáři ve SmartMaileru v sekci "Odhlášky" po vytvoření adresáře)') . '
        </div></div>';
        $this->_html .= '</div>';


        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Přenášet pouze zákazníky, kteří souhlasili s newsletterem?') . '</label>';
        $this->_html .= '<div class="col-lg-9">
		<span class="switch prestashop-switch fixed-width-lg">
										<input name="prenaset_pouze_newsletter" id="prenaset_pouze_newsletter_on" value="1"' . ((Configuration::get($this->name . '_prenaset_pouze_newsletter') == 1) ? ' checked="checked"' : '') . ' type="radio">
										<label for="prenaset_pouze_newsletter_on">' . $this->l('ANO') . '</label>
										<input name="prenaset_pouze_newsletter" id="prenaset_pouze_newsletter_off" value="0"' . ((Configuration::get($this->name . '_prenaset_pouze_newsletter') == 0) ? ' checked="checked"' : '') . ' type="radio">
										<label for="prenaset_pouze_newsletter_off">' . $this->l('NE') . '</label>
										<a class="slide-button btn"></a>
									</span></div><div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('Pokud zvolíte "ANO", přenesou se pouze zákazníci, kteří souhlasili s newsletterem, pokud dáte "NE", přenese se vše.') . '
        </div></div>';
        $this->_html .= '</div>';

        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Přenášet i kontakty, které se přihlásily přes newsletter formulář?') . '</label>';
        $this->_html .= '<div class="col-lg-9">
		<span class="switch prestashop-switch fixed-width-lg">
										<input name="prenaset_z_newsletter_modulu" id="prenaset_z_newsletter_modulu_on" value="1"' . ((Configuration::get($this->name . '_prenaset_z_newsletter_modulu') == 1) ? ' checked="checked"' : '') . ' type="radio">
										<label for="prenaset_z_newsletter_modulu_on">' . $this->l('ANO') . '</label>
										<input name="prenaset_z_newsletter_modulu" id="prenaset_z_newsletter_modulu_off" value="0"' . ((Configuration::get($this->name . '_prenaset_z_newsletter_modulu') == 0) ? ' checked="checked"' : '') . ' type="radio">
										<label for="prenaset_z_newsletter_modulu_off">' . $this->l('NE') . '</label>
										<a class="slide-button btn"></a>
									</span></div><div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('Jedná se o kontakty, které se přihlásily přes modul "ps_emailsubscription" a "blocknewsletter"') . '
        </div></div>';
        $this->_html .= '</div>';


        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Přenášet pouze kontakty, které mají nějakou zrealizovanou objednávku') . '</label>';
        $this->_html .= '<div class="col-lg-9">
		<span class="switch prestashop-switch fixed-width-lg">
										<input name="prenaset_s_obj" id="prenaset_s_obj_on" value="1"' . ((Configuration::get($this->name . '_prenaset_s_obj') == 1) ? ' checked="checked"' : '') . ' type="radio">
										<label for="prenaset_s_obj_on">' . $this->l('ANO') . '</label>
										<input name="prenaset_s_obj" id="prenaset_s_obj_off" value="0"' . ((Configuration::get($this->name . '_prenaset_s_obj') == 0) ? ' checked="checked"' : '') . ' type="radio">
										<label for="prenaset_s_obj_off">' . $this->l('NE') . '</label>
										<a class="slide-button btn"></a>
									</span></div><div class="col-lg-9 col-lg-offset-3"><div class="help-block">
             ' . $this->l('Tyto objednávky se vyhodnocují na základě nastavení stavů v sekci "Stavy objednávek, které se mají brát jako zrealizovaná objednávka" o pár řádků níže') . '
        </div></div>';
        $this->_html .= '</div>';
        /*
                $this->_html .= '<div class="form-group">';
                $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Aktualizovat kontakty?') . '</label>';
                $this->_html .= '<div class="col-lg-9">
                <span class="switch prestashop-switch fixed-width-lg">
                                                <input name="kontakty_aktualizace" id="kontakty_aktualizace_on" value="1"' . ((Configuration::get($this->name . '_kontakty_aktualizace') == 1) ? ' checked="checked"' : '') . ' type="radio">
                                                <label for="kontakty_aktualizace_on">' . $this->l('ANO') . '</label>
                                                <input name="kontakty_aktualizace" id="kontakty_aktualizace_off" value="0"' . ((Configuration::get($this->name . '_kontakty_aktualizace') == 0) ? ' checked="checked"' : '') . ' type="radio">
                                                <label for="kontakty_aktualizace_off">' . $this->l('NE') . '</label>
                                                <a class="slide-button btn"></a>
                                            </span></div><div class="col-lg-9 col-lg-offset-3"><div class="help-block">
                      ' . $this->l('Pokud zvolíte "ANO", budou se kontakty při každém spuštění aktualizovat, pokud dáte "NE", přenesou se kontakty pouze poprvé a poté se již neaktualizují. Ve své podstatě není třeba kontakty moc aktualizovat, jelikož podstatný údaj je e-mail a ten se nemění. Doporučujeme ponechat na volbě "NE". Tato funkce je převážně servisního charakteru, ponechte ji vždy VYPNOU na volbě "NE". Funkce má jediný Možná do budoucna bude tato volba mít více funkcionalit s tím, jak se bude systém Smart Mailer rozšiřovat.') . '
                </div></div>';
                $this->_html .= '</div>';
        */

        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Měřit jako konverzi pouze první nákup?') . '</label>';
        $this->_html .= '<div class="col-lg-9">
		<span class="switch prestashop-switch fixed-width-lg">
										<input name="konverze_pouze_poprve" id="konverze_pouze_poprve_on" value="1"' . ((Configuration::get($this->name . '_konverze_pouze_poprve') == 1) ? ' checked="checked"' : '') . ' type="radio">
										<label for="konverze_pouze_poprve_on">' . $this->l('ANO') . '</label>
										<input name="konverze_pouze_poprve" id="konverze_pouze_poprve_off" value="0"' . ((Configuration::get($this->name . '_konverze_pouze_poprve') == 0) ? ' checked="checked"' : '') . ' type="radio">
										<label for="konverze_pouze_poprve_off">' . $this->l('NE') . '</label>
										<a class="slide-button btn"></a>
									</span></div><div class="col-lg-9 col-lg-offset-3"><div class="help-block">
              ' . $this->l('Toto nastavení slouží pro výpočet statistik v modulu níže a pro měření počtu konverzí v systému SmartMailer. Pokud zadáte hodnotu "NE". Bude se měřit každý nákup, který zákazník udělá až do doby vypršení platnosti cookies. Např. pokud máte nastavenou platnost cookies třeba 1 rok a zákazník si otevře newsletter a v době do 1 roku od otevření newsletteru nakoupí 2x z toho samého zařízení, co otevřel newsletter, zaznamenají se dvě konverze. Pokud nastavíte tuto volbu na "ANO", změří se pouze první nákup a další nákup již ne (nebude se brán jako konverze). Druhý nákup by se změřil pouze v případě, že by zákazník otevřel nějaký další newsletter až PO prvním nákupu.') . '
        </div></div>';
        $this->_html .= '</div>';


        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Nahrávat pouze aktivní kontakty za posledních X měsíců ') . '</label>';
        $this->_html .= '<div class="col-lg-9">
                <input type="text" name="months_active" value="' . (int)Configuration::get($this->name . '_months_active') . '"></div>
                <div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('Za aktivní kontakt považujeme ten, který se za posledních X měsíců zaregistroval a takový, který se zaregistroval před více jak X měsíci, ale zároveń za posledních X měsíců něco na e-shopu zakoupil. Toto nastavení zajistí, že nebudete přenášet "mrtvé kontakty" a platit za zbytečné kontakty navíc. Default nastavení je 36 měsíců.') . '
        </div></div>';
        $this->_html .= '</div>';


        $states = OrderState::getOrderStates($this->context->language->id);
        if ($states) {
            $state_waiting = unserialize(Configuration::get($this->name . '_state_waiting'));
            $this->_html .= '<div class="form-group">';

            $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Stavy objednávek, které se mají brát jako "konverzní"') . '</label>';

            $this->_html .= '<div class="col-lg-9"><div class="row">';
            foreach ($states as $s) {
                $checked = (isset($state_waiting[$s['id_order_state']])) ? ' checked="checked"' : '';
                $this->_html .= '<div class="checkbox col-md-4"><label for="tmp_' . $s['id_order_state'] . '">
                    <input type="checkbox" class="ruka"
                    name="state_waiting[' . $s['id_order_state'] . ']"
                    id="tmp_' . $s['id_order_state'] . '"
                    value="' . $s['id_order_state'] . '"
                    ' . $checked . '>
                    ' . $s['name'] . ' (ID: ' . $s['id_order_state'] . ')</label></div>';
            }
            $this->_html .= '</div></div><div class="col-lg-9 col-lg-offset-3"><div class="help-block">
				' . $this->l('Zvolte všechny stavy objednávek u kterých chcete, aby byly považovány za úspěšnou konverzi (tato konverze se přenese do systému SmartMailer). Teoreticky každý stav by měl být konverzní, jelikož nás zajímá, kolik lidí udělalo objednávku na základě mailingu. Nicméně, pokud chcete brát v potaz pouze úspěšně dokončené OBJ a ty brát jako konverze (což není úplně standardní), napárujte to např. pouze na na stavy "Doručeno", "Odesláno", "Platba byla přijata" atd.') . '
				</div></div>

				</div>';
        }

        if ($states) {
            $state_realized = unserialize(Configuration::get($this->name . '_state_realized'));
            $this->_html .= '<div class="form-group">';

            $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Stavy objednávek, které se mají brát jako "zrealizovaná objednávka"') . '</label>';

            $this->_html .= '<div class="col-lg-9"><div class="row">';
            foreach ($states as $s) {
                $checked = (isset($state_realized[$s['id_order_state']])) ? ' checked="checked"' : '';
                $this->_html .= '<div class="checkbox col-md-4"><label for="tmp_2_' . $s['id_order_state'] . '">
                    <input type="checkbox" class="ruka"
                    name="state_realized[' . $s['id_order_state'] . ']"
                    id="tmp_2_' . $s['id_order_state'] . '"
                    value="' . $s['id_order_state'] . '"
                    ' . $checked . '>
                    ' . $s['name'] . ' (ID: ' . $s['id_order_state'] . ')</label></div>';
            }
            $this->_html .= '</div></div><div class="col-lg-9 col-lg-offset-3"><div class="help-block">
				' . $this->l('Zvolte všechny stavy objednávek u kterých chcete, aby byly považovány za zrealizovanou objednávku v souvislosti s nastavením "Přenášet pouze kontakty, které mají nějakou zrealizovanou objednávku", pokud ho máte nastaveno na hodnotu "ANO". Typicky by zde měly být zohledněné pouze stavy typu "Dodáno", "Doručeno", "Dokončeno", apod. Aby nevstupovaly do toho např "Storno", "Vráceno" apod. Ale to je spíše už na každém, jak toto nastavení učiní. Nejde nastavit "špatně", jde nastavit jen tak, jak sami chcete a je spojeno opravdu jen s funkcí "Přenášet pouze kontakty, které mají nějakou zrealizovanou objednávku".') . '
				</div></div>

				</div>';
        }

        $prumerna_marze = (int)Configuration::get($this->name . '_prumerna_marze');
        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Vaše průměrná čistá marže (%)') . '</label>';
        $this->_html .= '<div class="col-lg-9">
                <input type="text" name="prumerna_marze" value="' . $prumerna_marze . '"></div>
                <div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('Tato průměrná marže se použije pro výpočet orientačního čistého zisku, pokud nebude u produktů zadána VO cena. Zvolte orientační průměrnou čistou marži, toto slouží jako doplněk výpočtu, pokud Vám někde bude chybět tato hodnota vyplněná u produktů. Hodnotu zadejte v %.') . '
        </div></div>';
        $this->_html .= '</div>';

        $platnost_cookies = (int)Configuration::get($this->name . '_platnost_cookies');
        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Platnost cookies ve dnech') . '</label>';
        $this->_html .= '<div class="col-lg-9">
                <input type="text" name="platnost_cookies" value="' . $platnost_cookies . '"></div>
                <div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('Délka platností cookies ve dnech (default 365), toto znamená, pokud se někdo proklikne přes newsletter do Vašeho e-shopu po jakou dobu budeme brát v potaz, aby se započítala konverze. Např, pokud uvedete platnost cookies 30 dní a zákazník nakoupí na Vašem e-shopu za 31 dní od prokliknutí newsletteru, konverze se nezměří (nebude to bráno jako konverze ze SmartMaileru)') . '
        </div></div>';
        $this->_html .= '</div>';

        $csv_delimiter = Configuration::get($this->name . '_csv_delimiter');
        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Oddělovač v CSV') . '</label>';
        $this->_html .= '<div class="col-lg-9">
                <input type="text" name="csv_delimiter" value="' . $csv_delimiter . '"></div>
                <div class="col-lg-9 col-lg-offset-3"><div class="help-block">
        ' . $this->l('Excel oddělovač pro export zákazníků/objednávek. Default ; (středník)') . '
        </div></div>';
        $this->_html .= '</div>';

        $cron_token = Configuration::get($this->name . '_cron_token');
        $this->_html .= '<div class="form-group">';
        $this->_html .= '<label class="control-label col-lg-3">' . $this->l('Bezpečnostní token pro cron') . '</label>';
        $this->_html .= '<div class="col-lg-9"><input type="text" name="cron_token" maxlength="32" value="' . $cron_token . '"></div>';
        $this->_html .= '<div class="col-lg-9 col-lg-offset-3"><div class="help-block">
				' . $this->l('Token slouží k zabezpečení cron úlohy, aby ji nemohl spustit každý. Pokud zadáte nějaký Váš libovolný text tokenu, změní se po uložení nastavení i URL adresa pro cron! Max 32 znaků, pouze znaky a-z, A-Z a 0-9, nepoužívejte mezery, háčky, čárky, speciální znaky apod.') . '
				</div></div>';
        $this->_html .= '</div>';


        $this->_html .= '<div class="panel-footer">
			<button type="submit" class="btn btn-default pull-right" name="submit_text"><i class="process-icon-save"></i>' . $this->l('Uložit') . '</button></form></div>';
        $this->_html .= '</div></div></div>'; //FRAME END


        $this->_html .= '<div class="row"><div class="col-lg-12">			 
		<div class="panel"><div class="panel-heading"><i class="icon-list"></i> ' . $this->l('CRON & URL & INFO') . '</div>'; // FRAME
        $url1_tmp = $this->full_url . 'modules/' . $this->name . '/shaim_cron.php?cron_token=' . $cron_token;
        $url2_tmp = $this->full_url . 'modules/' . $this->name . '/' . $this->name . '_odhlaseni.php?email=#EMAIL#';

        $this->_html .= $this->l('URL adresa pro nastavení do cronu (plánovač úloh, např. 1x za hodinu). Slouží pro přenos kontaktů, aktualizaci dat a přenos zaznamených konverzí (objednávek) z PrestaShopu do systému SmartMailer.') . "<br /><a href='$url1_tmp' target='_blank'>$url1_tmp</a>";


        $this->_html .= '<br /><br />' . $this->l('URL adresa pro odhlášení z mailing listu (PS+smartmailer.cz):') . "<br /><a href='$url2_tmp' target='_blank'>$url2_tmp</a><br />" . $this->l('Samotný SmartMailer má vlastní odhlašovací URL adresu, která kontekty ovlivňuje pouze na SmartMaileru. Pokud chcete zároveň měnit i stav kontaktu v PS (přihlášení k newsletteru), využijte tento odkaz zde z modulu a použijte ho v šabloně Vašeho e-mailu v SmartMaileru.');

        /* OBSOLETE - nyni jiz ONLY API
                $url_customers_csv = $url1_tmp . '&customers_csv';
                $this->_html .= "<br /><br /><a href='$url_customers_csv' target='_blank'>" . $this->l('Stáhnout zákazníky v CSV:') . "</a>";
                $this->_html .= '<br />' . $this->l('Po kliknutí na odkaz vyčkejte, může to trvat i desítky vteřin v závislosti na počtu zákazníků. CSV poté můžete nahrát přímo v aplikaci SmartMailer.') . '<strong>' . $this->l('Toto řešení je zachováno jen kvůli zpětné kompatibilitě, je zastaralé. Využijte prosím pravidelné API přenosy v tomto modulu, které jsou plně aktualizované bez nutnosti ruční práce v podobě CSV přenosů.') . '</strong>';
        */

        $url_orders_csv = $url1_tmp . '&orders_csv';
        $this->_html .= "<br /><br /><a href='$url_orders_csv' target='_blank'>" . $this->l('Stáhnout konverzní objednávky v CSV:') . "</a>";
        $this->_html .= '<br />' . $this->l('Po kliknutí na odkaz vyčkejte, může to trvat i desítky vteřin v závislosti na počtu objednávek. Toto CSV slouží pro případnou další práci s objednávkami, abyste věděli, které OBJ jsou konverzní a můžete si dle toho v Excelu dělat pokročilé výpočty. V exportu jsou pouze objednávky, které jsou konverzní (tzn, vznikly na základě prokliku ze systému SmartMailer.cz).');

        $this->_html .= '</div></div></div>'; //FRAME END


        $state_waiting = unserialize(Configuration::get($this->name . '_state_waiting'));
        $state_waiting_sql = '';
        if ($state_waiting) {
            $state_waiting_sql = ' && (o.`current_state` = ' . implode(' || o.`current_state` = ', $state_waiting) . ')';
        }


        $total_konverze = Db::getInstance()->getRow("SELECT SUM(`total_paid` / `conversion_rate`) as total_paid, SUM(`total_paid_tax_excl` / `conversion_rate`) as total_paid_tax_excl, SUM(total_wrapping_tax_excl / conversion_rate) as total_wrapping_tax_excl, SUM(`total_shipping_tax_excl` / `conversion_rate`) as total_shipping_tax_excl, COUNT(*) as pocet FROM `" . _DB_PREFIX_ . "orders` as o WHERE `uuid_smartmailer` IS NOT NULL && `uuid_smartmailer` != '' && `uuid_smartmailer` != '0' && `uuid_smartmailer_odeslano` = 1$state_waiting_sql;");

        $tmp_orders = Db::getInstance()->executeS("SELECT od.`original_wholesale_price`, od.`unit_price_tax_excl`, od.`product_quantity`, o.`conversion_rate` FROM `" . _DB_PREFIX_ . "orders` as o
        INNER JOIN `" . _DB_PREFIX_ . "order_detail` as od ON (o.`id_order` = od.`id_order`)
        WHERE o.`uuid_smartmailer` IS NOT NULL && o.`uuid_smartmailer` != '' && o.`uuid_smartmailer` != '0' && o.`uuid_smartmailer_odeslano` = 1$state_waiting_sql;");
        if ($tmp_orders) {


            if ($total_konverze['total_paid'] > 0) {
                $this->_html .= '<div class="row"><div class="col-lg-12">			 
		<div class="panel"><div class="panel-heading"><i class="icon-list"></i> ' . $this->l('Statistiky') . '</div>'; // FRAME

                $total_konverze['total_paid_tax_excl_bez_postovneho'] = $total_konverze['total_paid_tax_excl'] - $total_konverze['total_wrapping_tax_excl'] - $total_konverze['total_shipping_tax_excl'];


                $this->_html .= $this->l('Konverze ze SmartMaileru jsou aktuálně minimálně v této částce (s DPH): ') . '<strong>' . Tools::displayPrice($total_konverze['total_paid']) . '</strong>';
                $this->_html .= "<br /><br />" . $this->l('Částka bez DPH a bez poštovného/balného: ') . '<strong>' . Tools::displayPrice($total_konverze['total_paid_tax_excl_bez_postovneho']) . '</strong>';

                if ($prumerna_marze > 0) {
                    $total_konverze['orientacni_cisty_zisk'] = 0;
                    foreach ($tmp_orders as $tmp_o) {
                        $original_wholesale_price = (float)$tmp_o['original_wholesale_price'];
                        $unit_price_tax_excl = (float)$tmp_o['unit_price_tax_excl'];

                        // Pokud je prodeni cena nizsi nez nakupni, Bereme to jako chybu a pouzivame prumernou marzi
                        // Nebo kdyz neni uvedena nakupni cena, tak musime pouzit tu prumernou marzi
                        if ($unit_price_tax_excl <= $original_wholesale_price || $original_wholesale_price == 0.000000) {
                            $mezivypocet = ($unit_price_tax_excl / 100 * $prumerna_marze);
                            $this_round = ($mezivypocet * $tmp_o['product_quantity']) / $tmp_o['conversion_rate'];
                        } else {
                            $this_round = (($unit_price_tax_excl - $original_wholesale_price) * $tmp_o['product_quantity']) / $tmp_o['conversion_rate'];
                        }
                        $total_konverze['orientacni_cisty_zisk'] += $this_round;

                    }

                    $this->_html .= "<br /><br />" . $this->l('Orientační čistý zisk: ') . '<strong>' . Tools::displayPrice($total_konverze['orientacni_cisty_zisk']) . '</strong><br />';
                }

                $this->_html .= "<br />" . $this->l('Minimální počet konverzí: ') . '<strong>' . $total_konverze['pocet'] . '</strong>';

                $this->_html .= "<br />" . $this->l('Průměrná hodnota objednávky: ') . '<strong>' . Tools::displayPrice(round($total_konverze['total_paid'] / $total_konverze['pocet'], 0)) . '</strong>';
                $this->_html .= "<br /><br /><small>" . $this->l('Uvedené statistiky nemusí úplně 100% souhlasit s administrací smartmailer.cz, berte to prosím orientačně, vlivů na rozdílnost statistik je více, ale neměl by tam být žádný výrazný rozdíl. Směrodatnější je statistika zde v tomto modulu, jelikož shrnuje veškeré konverze lifetime a zároveň rozlišuje i úspěšně dokončenou OBJ (jestli nebyla zrušena apod.), což systém Smartmailer z podstaty věci nemůže umět, protože je to pouze nástroj na newsletter, který již nepozná, jestli OBJ nebyla později zrušena (po úspěšném dokončení) - např. vrácení v 14 denní lhůtě, reklamace, apod..') . '</small>';
                $this->_html .= "<br /><br /><small>" . $this->l('Veškeré hodnoty v cizí měně jsou konvertovány kurzem do měny domácí (nastavené v e-shopu jako defaultní).') . '</small>';
                $this->_html .= '</div></div></div>'; //FRAME END
            }


        }


        $this->_html .= '<div class="row"><div class="col-lg-12">			 
		<div class="panel"><div class="panel-heading"><i class="icon-list"></i> ' . $this->l('Pokročilé (servisní) funkce (běžně by nemělý být potřeba)') . '</div>'; // FRAME
        $tmp_reset_url = $url1_tmp . '&reset_exported_smartmailer';
        $this->_html .= '<strong>' . $this->l('Resetování informace o tom, kteří zákazníci již byli přeneseni do SmartMaileru:') . "</strong><br /><a class='btn btn-default' href='$tmp_reset_url' target='_blank'>" . $this->l('Resetovat') . "</a><br />";
        $this->_html .= '<small>' . $this->l('Tato servisní funkce slouží defakto pro jeden velmi specifický případ. V případě, že z nějakého důvodu potřebujete ve SmartMaileru kontakty přenést znovu do JINÉHO adresáře a zároveň máte v e-shopu mnoho kontaktů, že se Vám to nedaří pomocí zapnutí přepínače "Aktualizovat kontakty". Toto tlačítko použijte tedy pouze v tomto případě. Díky tomu zajistíte, že se vám kontakty "resetují" v PS a začnou se znovu přenášet do zvoleného adresáře ve SmartMaileru.') . '</small>';

        $this->_html .= '</div></div></div>'; //FRAME END


        $this->_html .= '<div class="row"><div class="col-lg-12">			 
		<div class="panel"><div class="panel-heading"><i class="icon-info"></i> ' . $this->l('Informace') . '</div>'; // FRAME
        $this->_html .= '<br /><br /><br /><div class="clear_both"><small>' . $this->credits . '<br />' . $this->description . (($this->module_url) ? '<br />URL: <a href="' . $this->module_url . '" target="_blank">' . $this->module_url . '</a>' : '') . '</small></div>';
        $this->_html .= '</div></div></div>'; //FRAME END
        $this->CheckModuleUpdateFromSettings();
        $this->CheckModuleHooks();
        return $this->_html;
    }
}
/**
 * @license https://psmoduly.cz/ ; Licenční podmínky: https://psmoduly.cz/content/8-licencni-podminky ; Obchodní
 *     podmínky: https://psmoduly.cz/content/3-obchodni-podminky
 * @copyright: 2014-2024 Dominik "Shaim" Ulrich
 * @author: Dominik "Shaim" Ulrich
 * E-mail: info@psmoduly.cz / info@openservis.cz
 * Websites: www.psmoduly.cz / www.openservis.cz
 **/
