<?php

if (!defined('_PS_VERSION_')) {
    exit;
}

// Copy z 2_0_9
function upgrade_module_2_1_0($module)
{
    $module->registerHook('actionValidateOrder');
    $module->unregisterHook('displayOrderConfirmation');
    if (!Configuration::get($module->name . '_prumerna_marze')) {
        Configuration::updateValue($module->name . '_prumerna_marze', (int)Configuration::get('CONF_AVERAGE_PRODUCT_MARGIN'));
    }
    if (!Configuration::get($module->name . '_platnost_cookies')) {
        Configuration::updateValue($module->name . '_platnost_cookies', 365);
    }
    if (!Configuration::get($module->name . '_csv_delimiter')) {
        Configuration::updateValue($module->name . '_csv_delimiter', ';');
    }
    $module->registerHook('actionAdminControllerSetMedia');

    // Zpetna kompatibilita na ty skupiny
    $languages = Language::getLanguages();
    $groups_apply = unserialize(Configuration::get($module->name . '_groups_apply'));
    if ($groups_apply) {
        foreach ($languages as $l) {
            foreach ($groups_apply as $g) {
                // Pokud existuje UUID kontaktu z minule verze
                $uuid_kontaktu_old = Configuration::get($module->name . '_uuid_kontaktu_' . $l['iso_code']);
                if ($uuid_kontaktu_old) {
                    $uuid_kontaktu_new = Configuration::get($module->name . '_uuid_kontaktu_' . $l['iso_code'] . '_' . $g['id_group']);
                    // a zaroven pokud uz nema hodnotu, abychom neprepsali neco, co uz tam je.
                    if (!$uuid_kontaktu_new) {
                        Configuration::updateValue($module->name . '_uuid_kontaktu_' . $l['iso_code'] . '_' . $g['id_group'], $uuid_kontaktu_old);
                    }
                }

            }
            // Mazeme, uz nepotrebujeme
            Configuration::deleteByName($module->name . '_uuid_kontaktu_' . $l['iso_code']);

        }

    }
    Configuration::deleteByName($module->name . '_groups_apply');

    // tohle je uplne obsolete, jeste bez jazyku, pryc s tim
    Configuration::deleteByName($module->name . '_uuid_kontaktu');
    // tohle je uplne obsolete, v prvni verzi, to blbnulo s PS tokenem :-D tak jsme to prejmenovali na api_token
    Configuration::deleteByName($module->name . '_token');
    return true;
}
